#include <lynx.h>
#include <lynxlib.h>
#include <stdlib.h>

// Bug in cc65? Needs real code before C++ comments occur?



// SPRDEMO2
// 2. April 2000
// Shows the usage of SPRPCK to create 8 tiles (2 rows with 4 columns)
// Inspite to SPRDEMO1, the craeted sprites will have only 2 bit colour depth
// because each tile has just 3 colours:
//   black, cyan and the individual tile background
// So if we want to show such a tile, we have to set an individual
// colour palette index table in the SCB!
//
// ----------------------------------------------------------------------
//
// Create the 8 tiles by calling SPRPCK with these parameters:
//
// sprpck -t6 -S040051 -r004002 -p0 -c -z -v yx.bmp > sprites2.txt
//
// -t6      --> source is a MS Windows BMP-file
// -Swwwhhh --> capital S, set the width and height of the created sprite(s)
// -rxxxyyy --> split source image into yyy*xxx tiles (of -Swwwhhh size)
// -p0      --> creates OBJ-files from the SPR-files
// -c       --> compress colour indexes
// -z       --> automatically set pixel depth
// -v       --> don't be quiet: tell us about the creating of the sprites
// yx.bmp   --> the source file is a BMP with 160*102 pixels (w*h)
// > sprites2.txt --> to get the used colour index palettes of each tile
//
// The created sprites will have a 2bit colour depth


// Here is a part of sprites2.txt:
// (You have to insert the linefeeds for the correct display of the Pixel-table)
/******************
Tile nr: 1
   0|   1|   2|   3|   4|   5|   6|   7|   8|   9|  10|  11|  12|  13|  14|  15|
----+----+----+----+----+----+----+----+----+----+----+----+----+----+----+----+
 212|1470|   0|   0|   0|   0|   0|   0|   0|   0|   0|   0|   0|   0| 358|   0|
Pixel sum: 2040
Colors used: 3
Index table:
01------------2-
Written: yx000000.obj 
******************/

// You need to compare the "Index table"-parts of each tile to build
// the sprndx-table entries:
//
// Each tile has just three colours. In this example, for all tiles
// the colour indexes 0 and 2 are the same,
// index 1 is the tile specific one and
// index 3 is never used
char sprndx[2*4][2] = {{0x01,0xe0},{0x03,0xe0},{0x02,0xe0},{0x04,0xe0},
                       {0x09,0xe0},{0x0b,0xe0},{0x0a,0xe0},{0x0c,0xe0}};


// Access to the created 8 sprites:

// The 4 sprites of the first row
extern char yx000000[];
extern char yx000001[];
extern char yx000002[];
extern char yx000003[];

// The 4 sprites of the second row
extern char yx001000[];
extern char yx001001[];
extern char yx001002[];
extern char yx001003[];

char *sprtab[2][4] = {{yx000000, yx000001, yx000002, yx000003},
                      {yx001000, yx001001, yx001002, yx001003}};

extern char SCB1[];
#asm         
_SCB1     dc.b $40,$10,$20
          dc.w 0,0
          dc.w 0,0,$100,$100
          ; We used -c when calling SPRPCK, so  we can _not_
          ; use the same colour palette indexes for all tiles!
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm


// The colour palette
#include "yx.pal"


/*********************/
/* wait for a button */
/*********************/
uchar WaitButton()
{
   uchar key;
   while ( !(key = joystick))
      ;
   /* wait for the button to be released */
   while ( joystick )
      ;
   return key;
}


/*********************/
/* main              */
/*********************/
main()
{
register uchar x,y;

  CLI;
  SetBuffers(0x9000,0,0);

  _SetRGB(pal);                         // Set the colour palette

  for (;;)
     {
     /*******************************************************************
      Show all the 2bit-sprites with the same colour palette index table:
     *******************************************************************/

     // Set the colour palette index entries to their default values:
     SCB1[15] = 0x01;
     SCB1[16] = 0x23;

     // "Clear" screen:
     DrawFBox(0, 0, 160, 102, 15);      // Colour 15 is white

     for (y=0; y<2; ++y)                // 2 rows
        {
        for (x=0; x<4; ++x)             // 4 columns
           {
           SCBX(SCB1) = 40*x;
           SCBY(SCB1) = 51*y;
           SCBDATA(SCB1) = sprtab[y][x];
           DrawSprite(SCB1);
           WaitButton();
           }
        }

     /*******************************************************************
      Now show all the 2bit-sprites with their
      individual colour palette index table:
     *******************************************************************/

     // "Clear" screen:
     DrawFBox(0, 0, 160, 102, 15);      // Colour 15 is white

     for (y=0; y<2; ++y)                // 2 rows
        {
        for (x=0; x<4; ++x)             // 4 columns
           {
           // Set the colour palette index entries to tile specific values:
           SCB1[15] = sprndx[4*y+x][0];
           SCB1[16] = sprndx[4*y+x][1];

           SCBX(SCB1) = 40*x;
           SCBY(SCB1) = 51*y;
           SCBDATA(SCB1) = sprtab[y][x];
           DrawSprite(SCB1);
           WaitButton();
           }
        }

     } // forever
}
