#include <lynx.h>
#include <lynxlib.h>
#include <stdlib.h>

// Bug in cc65? Needs real code before C++ comments occur?



// SPRDEMO3
// 2. April 2000
// Shows the usage of SPRPCK to create 9 tiles of
// 24*24 pixels with a hotspot at (12,12)
// All tiles share the same colour palette indexes
//
// ----------------------------------------------------------------------
//
// Create the 9 tiles by calling SPRPCK with these parameters:
// sprpck -t6 -S024024 -r009001 -p0 -a012012 mm.bmp
//
// -t6      --> source is a MS Windows BMP-file
// -Swwwhhh --> capital S, set the width and height of the created sprite(s)
// -rxxxyyy --> split source image into yyy*xxx tiles (of -Swwwhhh size)
// -p0      --> creates OBJ-files from the SPR-files
// yx.bmp   --> the source file is a BMP with 216*48 pixels (w*h)
//
// The created sprites will have a 4bit colour depth


// Access to the created 9 sprites:

// The 9 sprites of the first row
extern char mm000000[];
extern char mm000001[];
extern char mm000002[];
extern char mm000003[];
extern char mm000004[];
extern char mm000005[];
extern char mm000006[];
extern char mm000007[];
extern char mm000008[];

char *sprtab[9] = {mm000000, mm000001, mm000002, mm000003,
                   mm000004, mm000005, mm000006, mm000007,
                   mm000008};

extern char SCB1[];
#asm         
_SCB1     dc.b $c0,$10,$20
          dc.w 0,0
          dc.w 0,0,$200,$200    ; size doubled!
          ; Because we didn't use -C when calling SPRPCK we can
          ; use the same colour palette indexes for all tiles
          dc.b $01,$23,$45,$67,$89,$Ab,$cd,$ef
#endasm


// The colour palette
#include "mm.pal"

// Table for the flip-values for the 4 quadrants
hvflip[4] = {0xc0, 0xd0, 0xf0, 0xe0};


#define JOY_RIGHT  0x10
#define JOY_LEFT   0x20
#define JOY_UP     0x80
#define JOY_DOWN   0x40

#define BUTTON_OPTION1 0x08
#define BUTTON_OPTION2 0x04
#define BUTTON_LEFT    0x02
#define BUTTON_RIGHT   0x01

#define BUTTON_PAUSE   0x01


uchar VBLflag at 0xff;

#define VSYNC {++VBLflag;while( VBLflag );}

VBL() interrupt
{
  IRQ_ENTRY();
  VBLflag = 0; /* indicates that a VBL has ocurred */
  IRQ_EXIT();
}

/*********************/
/* Pause some time   */
/*********************/
WaitTicks(waitticks)
uchar waitticks;
{
  uchar tick;

  tick = 0;
  while (tick < waitticks)
     {
     VSYNC;
     ++tick;
     }
}

/**********************************/
/* Return the next pressed button */
/**********************************/
uchar GetButton()
{
   uchar key;
   while ( !(key = joystick))
      ;
   return key;
}


/*********************/
/* main              */
/*********************/
main()
{
register uchar t, key;

  InitIRQ();
  InstallIRQ(2,VBL);
  EnableIRQ(2);
  CLI;


  SetBuffers(0x9000,0,0);

  _SetRGB(pal);                         // Set the colour palette

  DrawFBox(0, 0, 160, 102, 4);      // Colour 4 is dark gray

  SCBX(SCB1) = 80;
  SCBY(SCB1) = 51;

  t=0;
  for (;;)                
     {
     WaitTicks(5);           // Pause for 5 VSYNCs

     SCB1[0] = hvflip[t/9];  // Determine quadrant

     if ((t/9) == 0 || (t/9) == 2)
        SCBDATA(SCB1) = sprtab[t%9];      // normal tile order
     else
        SCBDATA(SCB1) = sprtab[8-(t%9)];  // backwards

     DrawSprite(SCB1);

     // Get user input
     key = GetButton();
     if (key == BUTTON_OPTION1)
        {
        DrawFBox(0, 0, 160, 102, 4);      // Colour 4 is dark gray
        SCBHS(SCB1) = 0x100;
        SCBVS(SCB1) = 0x100;
        }

     if (key == BUTTON_OPTION2)
        {
        DrawFBox(0, 0, 160, 102, 4);      // Colour 4 is dark gray
        SCBHS(SCB1) = 0x200;
        SCBVS(SCB1) = 0x200;
        }

     if (key & (BUTTON_LEFT | JOY_LEFT))
        {
        if (t==0)
           t = 4*9;
        --t;
        }
     if (key & (BUTTON_RIGHT | JOY_RIGHT))
        {
        if (t==4*9-1)
           t = -1;
        ++t;
        }
     } // forever
}
